extends Reference
const WSMessage = preload("WSMessage.gd")
const IntPoint = preload("IntPoint.gd")
const CreateIntPointRequest = preload("CreateIntPointRequest.gd")
const CreateIntPointResponse = preload("CreateIntPointResponse.gd")
const ReadIntPointRequest = preload("ReadIntPointRequest.gd")
const ReadIntPointResponse = preload("ReadIntPointResponse.gd")
const UpdateIntPointRequest = preload("UpdateIntPointRequest.gd")
const UpdateIntPointResponse = preload("UpdateIntPointResponse.gd")
const UpdateSetIntPointRequest = preload("UpdateSetIntPointRequest.gd")
const UpdateSetIntPointResponse = preload("UpdateSetIntPointResponse.gd")
const DeleteIntPointRequest = preload("DeleteIntPointRequest.gd")
const DeleteIntPointsRequest = preload("DeleteIntPointsRequest.gd")
const DeleteIntPointResponse = preload("DeleteIntPointResponse.gd")

# Declare member variables here. Examples:
# var a = 2
# var b = "text"


# Called when the node enters the scene tree for the first time.
func _ready():
    Messaging.registerPublisher("/IntPointService/do_Create", self, "Create")
    Messaging.subscribe("/IntPointService/Create", self, "Create")
    Messaging.registerPublisher("/IntPointService/do_Read", self, "Read")
    Messaging.subscribe("/IntPointService/Read", self, "Read")
    Messaging.registerPublisher("/IntPointService/do_Update", self, "Update")
    Messaging.subscribe("/IntPointService/Update", self, "Update")
    Messaging.registerPublisher("/IntPointService/do_Delete", self, "Delete")
    Messaging.subscribe("/IntPointService/Delete", self, "Delete")

# Called every frame. 'delta' is the elapsed time since the previous frame.
#func _process(delta):
#	pass
signal Create(In)
func Create_return(Out: CreateIntPointResponse):
    emit_signal("Create", {"payload": In.Payload})
func Create(In : CreateIntPointRequest):
    Websocket.send("POST",""/v1/point"",{"payload": In.Payload})
signal Read(In)
func Read_return(Out: ReadIntPointResponse):
    emit_signal("Read", {"id": In.Id,"fields": In.Fields})
func Read(In : ReadIntPointRequest):
    Websocket.send("GET",""/v1/point/"+str(In.Id)",{"id": In.Id,"fields": In.Fields})
signal Update(In)
func Update_return(Out: UpdateIntPointResponse):
    emit_signal("Update", {"payload": In.Payload,"gerogeriGegege": In.GerogeriGegege})
func Update(In : UpdateIntPointRequest):
    Websocket.send("PATCH",""/v1/point/"+str(In.Payload.Id)",{"payload": In.Payload,"gerogeriGegege": In.GerogeriGegege})
signal Delete(In)
func Delete_return(Out: DeleteIntPointResponse):
    emit_signal("Delete", {"id": In.Id})
func Delete(In : DeleteIntPointRequest):
    Websocket.send("DELETE",""/v1/point/"+str(In.Id)",{"id": In.Id})
